package com.dzeio.openhealth.db.dao

import androidx.lifecycle.LiveData
import androidx.room.*
import androidx.room.OnConflictStrategy.REPLACE
import com.dzeio.openhealth.core.BaseDao
import com.dzeio.openhealth.db.entities.Weight

@Dao
interface WeightDao : BaseDao<Weight> {

    @Query("SELECT * FROM Weight")
    fun getAll(): List<Weight>

    @Query("SELECT * FROM Weight where id = :weightId")
    fun getOne(weightId: Long): Weight?


    @Query("Select count(*) from Weight")
    fun getCount(): Int

    @Query("Select * FROM Weight WHERE id=(SELECT max(id) FROM Weight)")
    fun last(): Weight?
}