package com.dzeio.openhealth.ui.import

import android.app.ProgressDialog
import android.os.Build
import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ProgressBar
import android.widget.TextView
import androidx.annotation.RequiresApi
import androidx.fragment.app.Fragment
import androidx.lifecycle.ViewModelProvider
import com.dzeio.openhealth.connectors.GoogleFit
import com.dzeio.openhealth.databinding.FragmentImportBinding

class ImportFragment : Fragment() {

    private var _binding: FragmentImportBinding? = null

    // This property is only valid between onCreateView and
    // onDestroyView.
    private val binding get() = _binding!!
    private lateinit var viewModel: ImportViewModel

    private lateinit var progressDialog: ProgressDialog

    override fun onCreateView(
        inflater: LayoutInflater,
        container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View {
        viewModel = ViewModelProvider(this).get(ImportViewModel::class.java)

        _binding = FragmentImportBinding.inflate(inflater, container, false)
        val root: View = binding.root

        progressDialog = ProgressDialog(requireContext())

        progressDialog.apply {
            setProgressStyle(ProgressDialog.STYLE_HORIZONTAL)
            setCancelable(false)
        }

        return root
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        binding.importGoogleFit.setOnClickListener {
            importFromGoogleFit()
        }
    }

    override fun onDestroyView() {
        super.onDestroyView()
        _binding = null
    }

    @RequiresApi(Build.VERSION_CODES.O)
    fun importFromGoogleFit() {
        viewModel.importProgressTotal.postValue(-1)
        val google = GoogleFit(requireActivity())

        progressDialog.show()
        google.importWeight {
            progressDialog.dismiss()
        }
    }

    fun importFromSamsungHealth() {

    }
}